<?php
/**
 * @package     Cookie Same Site
 * @version     1.0
 * @author      Stergios Zgouletas <info@web-expert.gr>
 * @link        http://www.web-expert.gr
 * @copyright   Copyright (C) 2020-21 Web-Expert.gr All Rights Reserved
 * @license     http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.plugin.plugin');
class plgSystemCookiesamesite extends JPlugin
{
	protected $isTest=0;
	
	public function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
		
		$this->run();
	}

	public function run() //onAfterInitialise
	{
		$app=JFactory::getApplication();
		$this->isTest=$app->isAdmin() && $app->input->getInt('test'); //type on plugin edit page &test=1 or 0
		
		$this->setTestCookie('Before');
		$this->setSameSite();
		$this->setTestCookie('After');
	}
	
	function setSameSite()
	{
		$app=JFactory::getApplication();
		$cookieParams = session_get_cookie_params();
		$cookieParams['secure']	= $app->isSSLConnection();
		$cookieParams['samesite'] = $this->params->get('samesite','None');
		
		//Global default params
		@ini_set('session.cookie_secure',$cookieParams['secure']);
		@ini_set('session.cookie_samesite',$cookieParams['samesite']);
			
		if(PHP_VERSION_ID < 70300)
		{
			$cookieStr='samesite='.$cookieParams['samesite'];
			$app->set('cookie_path',$app->get('cookie_path', '/').'; '.$cookieStr); //bypass path
			
			if(strpos($cookieParams['path'],'samesite=')===false)
			{
				$cookieParams['path'].='; '.$cookieStr;
			}
			elseif(strpos($cookieParams['path'],$cookieStr)===false) //force to use our setting
			{
				$cookieParams['path']=preg_replace('/samesite=(.*)/',$cookieStr,$cookieParams['path']);
			}
		}
		else
		{
			//Apache header probably is the solution until joomla team will release some update
		}
		//session_set_cookie_params($cookieParams);		
	}
	
	function setTestCookie($value)
	{
		$app=JFactory::getApplication();
		if(!$app->isAdmin() || $app->input->getCmd('option')!='com_plugins' || $app->input->getCmd('view')!='plugin') return false;
		$expires=$this->isTest?2*60:-36000;
		$app->input->cookie->set('plg_samecookiesite_'.$value,'PHP_'.PHP_VERSION.'_Expecting_'.$this->params->get('samesite','None'),time()+$expires, $app->get('cookie_path', '/'), $app->get('cookie_domain'), $app->isSSLConnection());
	}
}